diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/visualizer/visualizer/core.py ns-3.41/src/visualizer/visualizer/core.py
--- ns-3.40/src/visualizer/visualizer/core.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/visualizer/visualizer/core.py	2024-02-09 14:44:08.561794800 -0800
@@ -1,10 +1,12 @@
 # -*- Mode: python; coding: utf-8 -*-
 from ctypes import c_double
 
-LAYOUT_ALGORITHM = 'neato' # ['neato'|'dot'|'twopi'|'circo'|'fdp'|'nop']
+LAYOUT_ALGORITHM = "neato"  # ['neato'|'dot'|'twopi'|'circo'|'fdp'|'nop']
 REPRESENT_CHANNELS_AS_NODES = 1
-DEFAULT_NODE_SIZE = 1.0 # default node size in meters
-DEFAULT_TRANSMISSIONS_MEMORY = 5 # default number of of past intervals whose transmissions are remembered
+DEFAULT_NODE_SIZE = 1.0  # default node size in meters
+DEFAULT_TRANSMISSIONS_MEMORY = (
+    5  # default number of of past intervals whose transmissions are remembered
+)
 BITRATE_FONT_SIZE = 10
 
 # internal constants, normally not meant to be changed
@@ -12,8 +14,9 @@
 PRIORITY_UPDATE_MODEL = -100
 PRIORITY_UPDATE_VIEW = 200
 
-import warnings
 import platform
+import warnings
+
 if platform.system() == "Windows":
     SHELL_FONT = "Lucida Console 9"
 else:
@@ -52,16 +55,12 @@
     svgitem = None
 
 try:
-    gi.require_version('GooCanvas', '2.0')
-    gi.require_version('Gtk', '3.0')
-    gi.require_version('Gdk', '3.0')
+    gi.require_version("GooCanvas", "2.0")
+    gi.require_version("Gtk", "3.0")
+    gi.require_version("Gdk", "3.0")
     gi.require_foreign("cairo")
-    from gi.repository import GObject
-    from gi.repository import GLib
-    from gi.repository import Gtk
-    from gi.repository import Gdk
-    from gi.repository import Pango
-    from gi.repository import GooCanvas
+    from gi.repository import Gdk, GLib, GObject, GooCanvas, Gtk, Pango
+
     from . import hud
 except ImportError as e:
     _import_error = e
@@ -73,13 +72,24 @@
 except ImportError:
     ipython_view = None
 
-from .base import InformationWindow, PyVizObject, Link, lookup_netdevice_traits, PIXELS_PER_METER
-from .base import transform_distance_simulation_to_canvas, transform_point_simulation_to_canvas
-from .base import transform_distance_canvas_to_simulation, transform_point_canvas_to_simulation
-from .base import load_plugins, register_plugin, plugins
+from .base import (
+    PIXELS_PER_METER,
+    InformationWindow,
+    Link,
+    PyVizObject,
+    load_plugins,
+    lookup_netdevice_traits,
+    plugins,
+    register_plugin,
+    transform_distance_canvas_to_simulation,
+    transform_distance_simulation_to_canvas,
+    transform_point_canvas_to_simulation,
+    transform_point_simulation_to_canvas,
+)
+
+PI_OVER_2 = math.pi / 2
+PI_TIMES_2 = math.pi * 2
 
-PI_OVER_2 = math.pi/2
-PI_TIMES_2 = math.pi*2
 
 ## Node class
 class Node(PyVizObject):
@@ -117,12 +127,16 @@
     #  highlighted property
     ## @var selected
     #  selected property
+    ## @var on_enter_notify_event
+    #  on_enter_notify_event function
+    ## @var on_leave_notify_event
+    #  on_leave_notify_event function
 
     ## signal emitted whenever a tooltip is about to be shown for the node
     ## the first signal parameter is a python list of strings, to which
     ## information can be appended
     __gsignals__ = {
-        'query-extra-tooltip-info': (GObject.SignalFlags.RUN_LAST, None, (object,)),
+        "query-extra-tooltip-info": (GObject.SignalFlags.RUN_LAST, None, (object,)),
     }
 
     def __init__(self, visualizer, node_index):
@@ -141,7 +155,7 @@
         self._has_mobility = None
         self._selected = False
         self._highlighted = False
-        self._color = 0x808080ff
+        self._color = 0x808080FF
         self._size = DEFAULT_NODE_SIZE
         self.canvas_item.connect("enter-notify-event", self.on_enter_notify_event)
         self.canvas_item.connect("leave-notify-event", self.on_leave_notify_event)
@@ -152,7 +166,7 @@
         self._label = None
         self._label_canvas_item = None
 
-        self._update_appearance() # call this last
+        self._update_appearance()  # call this last
 
     def set_svg_icon(self, file_base_name, width=None, height=None, align_x=0.5, align_y=0.5):
         """!
@@ -191,9 +205,9 @@
         if height is not None:
             self.svg_item.props.height = transform_distance_simulation_to_canvas(height)
 
-        #threshold1 = 10.0/self.svg_item.props.height
-        #threshold2 = 10.0/self.svg_item.props.width
-        #self.svg_item.props.visibility_threshold = min(threshold1, threshold2)
+        # threshold1 = 10.0/self.svg_item.props.height
+        # threshold2 = 10.0/self.svg_item.props.width
+        # self.svg_item.props.visibility_threshold = min(threshold1, threshold2)
 
         self.svg_align_x = align_x
         self.svg_align_y = align_y
@@ -224,9 +238,9 @@
         """
         w = self.svg_item.width
         h = self.svg_item.height
-        self.svg_item.set_properties(x=(x - (1-self.svg_align_x)*w),
-                                     y=(y - (1-self.svg_align_y)*h))
-
+        self.svg_item.set_properties(
+            x=(x - (1 - self.svg_align_x) * w), y=(y - (1 - self.svg_align_y) * h)
+        )
 
     def tooltip_query(self, tooltip):
         """!
@@ -242,52 +256,62 @@
             ipv4 = ns.cppyy.gbl.getNodeIpv4(ns3_node)
             ipv6 = ns.cppyy.gbl.getNodeIpv6(ns3_node)
 
-            name = '<b><u>Node %i</u></b>' % self.node_index
-            node_name = ns.Names.FindName (ns3_node)
-            if len(node_name)!=0:
-                name += ' <b>(' + node_name + ')</b>'
+            name = "<b><u>Node %i</u></b>" % self.node_index
+            node_name = ns.Names.FindName(ns3_node)
+            if len(node_name) != 0:
+                name += " <b>(" + node_name + ")</b>"
 
             lines = [name]
-            lines.append('')
+            lines.append("")
 
             self.emit("query-extra-tooltip-info", lines)
 
             mob = ns.cppyy.gbl.hasMobilityModel(ns3_node)
             if mob:
                 mobility_model_name = ns.cppyy.gbl.getMobilityModelName(ns3_node)
-                lines.append('  <b>Mobility Model</b>: %s' % ns.cppyy.gbl.getMobilityModelName(ns3_node))
+                lines.append(
+                    "  <b>Mobility Model</b>: %s" % ns.cppyy.gbl.getMobilityModelName(ns3_node)
+                )
 
             for devI in range(ns3_node.GetNDevices()):
-                lines.append('')
-                lines.append('  <u>NetDevice %i:</u>' % devI)
+                lines.append("")
+                lines.append("  <u>NetDevice %i:</u>" % devI)
                 dev = ns3_node.GetDevice(devI)
                 name = ns.Names.FindName(dev)
                 if name:
-                    lines.append('    <b>Name:</b> %s' % name)
+                    lines.append("    <b>Name:</b> %s" % name)
                 devname = dev.GetInstanceTypeId().GetName()
-                lines.append('    <b>Type:</b> %s' % devname)
+                lines.append("    <b>Type:</b> %s" % devname)
 
                 if ipv4 is not None:
                     ipv4_idx = ipv4.GetInterfaceForDevice(dev)
                     if ipv4_idx != -1:
                         addresses = [
-                            '%s/%s' % (ipv4.GetAddress(ipv4_idx, i).GetLocal(),
-                                       ipv4.GetAddress(ipv4_idx, i).GetMask())
-                            for i in range(ipv4.GetNAddresses(ipv4_idx))]
-                        lines.append('    <b>IPv4 Addresses:</b> %s' % '; '.join(addresses))
+                            "%s/%s"
+                            % (
+                                ipv4.GetAddress(ipv4_idx, i).GetLocal(),
+                                ipv4.GetAddress(ipv4_idx, i).GetMask(),
+                            )
+                            for i in range(ipv4.GetNAddresses(ipv4_idx))
+                        ]
+                        lines.append("    <b>IPv4 Addresses:</b> %s" % "; ".join(addresses))
 
                 if ipv6 is not None:
                     ipv6_idx = ipv6.GetInterfaceForDevice(dev)
                     if ipv6_idx != -1:
                         addresses = [
-                            '%s/%s' % (ipv6.GetAddress(ipv6_idx, i).GetAddress(),
-                                       ipv6.GetAddress(ipv6_idx, i).GetPrefix())
-                            for i in range(ipv6.GetNAddresses(ipv6_idx))]
-                        lines.append('    <b>IPv6 Addresses:</b> %s' % '; '.join(addresses))
+                            "%s/%s"
+                            % (
+                                ipv6.GetAddress(ipv6_idx, i).GetAddress(),
+                                ipv6.GetAddress(ipv6_idx, i).GetPrefix(),
+                            )
+                            for i in range(ipv6.GetNAddresses(ipv6_idx))
+                        ]
+                        lines.append("    <b>IPv6 Addresses:</b> %s" % "; ".join(addresses))
 
-                lines.append('    <b>MAC Address:</b> %s' % (dev.GetAddress(),))
+                lines.append("    <b>MAC Address:</b> %s" % (dev.GetAddress(),))
 
-            tooltip.set_markup('\n'.join(lines))
+            tooltip.set_markup("\n".join(lines))
         finally:
             self.visualizer.simulation.lock.release()
 
@@ -327,6 +351,7 @@
         """
         self._selected = value
         self._update_appearance()
+
     def _get_selected(self):
         """!
         Get selected function.
@@ -348,6 +373,7 @@
         """
         self._highlighted = value
         self._update_appearance()
+
     def _get_highlighted(self):
         """!
         Get highlighted function.
@@ -382,33 +408,37 @@
         if self.svg_item is not None:
             alpha = 0x80
         else:
-            alpha = 0xff
-        fill_color_rgba = (self._color & 0xffffff00) | alpha
-        self.canvas_item.set_properties(radius_x=size, radius_y=size,
-                                        fill_color_rgba=fill_color_rgba)
+            alpha = 0xFF
+        fill_color_rgba = (self._color & 0xFFFFFF00) | alpha
+        self.canvas_item.set_properties(
+            radius_x=size, radius_y=size, fill_color_rgba=fill_color_rgba
+        )
         if self._selected:
-            line_width = size*.3
+            line_width = size * 0.3
         else:
-            line_width = size*.15
+            line_width = size * 0.15
         if self.highlighted:
-            stroke_color = 'yellow'
+            stroke_color = "yellow"
         else:
-            stroke_color = 'black'
+            stroke_color = "black"
         self.canvas_item.set_properties(line_width=line_width, stroke_color=stroke_color)
 
         if self._label is not None:
             if self._label_canvas_item is None:
-                self._label_canvas_item = GooCanvas.CanvasText(visibility_threshold=0.5,
-                                                               font="Sans Serif 10",
-                                                               fill_color_rgba=0x808080ff,
-                                                               alignment=Pango.Alignment.CENTER,
-                                                               anchor=GooCanvas.CanvasAnchorType.N,
-                                                               parent=self.visualizer.canvas.get_root_item(),
-                                                               pointer_events=GooCanvas.CanvasPointerEvents.NONE)
+                self._label_canvas_item = GooCanvas.CanvasText(
+                    visibility_threshold=0.5,
+                    font="Sans Serif 10",
+                    fill_color_rgba=0x808080FF,
+                    alignment=Pango.Alignment.CENTER,
+                    anchor=GooCanvas.CanvasAnchorType.N,
+                    parent=self.visualizer.canvas.get_root_item(),
+                    pointer_events=GooCanvas.CanvasPointerEvents.NONE,
+                )
                 self._label_canvas_item.lower(None)
 
-            self._label_canvas_item.set_properties(visibility=GooCanvas.CanvasItemVisibility.VISIBLE_ABOVE_THRESHOLD,
-                                                   text=self._label)
+            self._label_canvas_item.set_properties(
+                visibility=GooCanvas.CanvasItemVisibility.VISIBLE_ABOVE_THRESHOLD, text=self._label
+            )
             self._update_position()
 
     def set_position(self, x, y):
@@ -429,7 +459,7 @@
             link.update_points()
 
         if self._label_canvas_item is not None:
-            self._label_canvas_item.set_properties(x=x, y=(y+self._size*3))
+            self._label_canvas_item.set_properties(x=x, y=(y + self._size * 3))
 
         # If the location of the point is now beyond the bounds of the
         # canvas then those bounds now need to be increased
@@ -458,7 +488,10 @@
         @param self: class object.
         @return x and y position
         """
-        return (self.canvas_item.get_property("center_x"), self.canvas_item.get_property("center_y"))
+        return (
+            self.canvas_item.get_property("center_x"),
+            self.canvas_item.get_property("center_y"),
+        )
 
     def _update_position(self):
         """!
@@ -480,7 +513,12 @@
         """
         if isinstance(color, str):
             color = Gdk.color_parse(color)
-            color = ((color.red>>8) << 24) | ((color.green>>8) << 16) | ((color.blue>>8) << 8) | 0xff
+            color = (
+                ((color.red >> 8) << 24)
+                | ((color.green >> 8) << 16)
+                | ((color.blue >> 8) << 8)
+                | 0xFF
+            )
         self._color = color
         self._update_appearance()
 
@@ -537,11 +575,15 @@
         @param channel: channel.
         """
         self.channel = channel
-        self.canvas_item = GooCanvas.CanvasEllipse(radius_x=30, radius_y=30,
-                                                   fill_color="white",
-                                                   stroke_color="grey", line_width=2.0,
-                                                   line_dash=GooCanvas.CanvasLineDash.newv([10.0, 10.0 ]),
-                                                   visibility=GooCanvas.CanvasItemVisibility.VISIBLE)
+        self.canvas_item = GooCanvas.CanvasEllipse(
+            radius_x=30,
+            radius_y=30,
+            fill_color="white",
+            stroke_color="grey",
+            line_width=2.0,
+            line_dash=GooCanvas.CanvasLineDash.newv([10.0, 10.0]),
+            visibility=GooCanvas.CanvasItemVisibility.VISIBLE,
+        )
         self.canvas_item.pyviz_object = self
         self.links = []
 
@@ -567,7 +609,10 @@
         @param self: class object.
         @return x / y position.
         """
-        return (self.canvas_item.get_property("center_x"), self.canvas_item.get_property("center_y"))
+        return (
+            self.canvas_item.get_property("center_x"),
+            self.canvas_item.get_property("center_y"),
+        )
 
 
 ## WiredLink
@@ -633,11 +678,11 @@
         """
         super(SimulationThread, self).__init__()
         assert isinstance(viz, Visualizer)
-        self.viz = viz # Visualizer object
+        self.viz = viz  # Visualizer object
         self.lock = threading.Lock()
         self.go = threading.Event()
         self.go.clear()
-        self.target_time = 0 # in seconds
+        self.target_time = 0  # in seconds
         self.quit = False
         self.sim_helper = ns.PyViz()
         self.pause_messages = []
@@ -664,30 +709,31 @@
         @return none
         """
         while not self.quit:
-            #print "sim: Wait for go"
-            self.go.wait() # wait until the main (view) thread gives us the go signal
+            # print "sim: Wait for go"
+            self.go.wait()  # wait until the main (view) thread gives us the go signal
             self.go.clear()
             if self.quit:
                 break
-            #self.go.clear()
-            #print "sim: Acquire lock"
+            # self.go.clear()
+            # print "sim: Acquire lock"
             self.lock.acquire()
             try:
                 if 0:
                     if ns3.Simulator.IsFinished():
                         self.viz.play_button.set_sensitive(False)
                         break
-                #print "sim: Current time is %f; Run until: %f" % (ns3.Simulator.Now ().GetSeconds (), self.target_time)
-                #if ns3.Simulator.Now ().GetSeconds () > self.target_time:
+                # print "sim: Current time is %f; Run until: %f" % (ns3.Simulator.Now ().GetSeconds (), self.target_time)
+                # if ns3.Simulator.Now ().GetSeconds () > self.target_time:
                 #    print "skipping, model is ahead of view!"
                 self.sim_helper.SimulatorRunUntil(ns.Seconds(self.target_time))
-                #print "sim: Run until ended at current time: ", ns3.Simulator.Now ().GetSeconds ()
+                # print "sim: Run until ended at current time: ", ns3.Simulator.Now ().GetSeconds ()
                 self.pause_messages.extend(self.sim_helper.GetPauseMessages())
                 GLib.idle_add(self.viz.update_model, priority=PRIORITY_UPDATE_MODEL)
-                #print "sim: Run until: ", self.target_time, ": finished."
+                # print "sim: Run until: ", self.target_time, ": finished."
             finally:
                 self.lock.release()
-            #print "sim: Release lock, loop."
+            # print "sim: Release lock, loop."
+
 
 ## ShowTransmissionsMode
 class ShowTransmissionsMode(object):
@@ -700,10 +746,13 @@
 
     ## enumeration
     __slots__ = []
+
+
 ShowTransmissionsMode.ALL = ShowTransmissionsMode()
 ShowTransmissionsMode.NONE = ShowTransmissionsMode()
 ShowTransmissionsMode.SELECTED = ShowTransmissionsMode()
 
+
 ## Visualizer
 class Visualizer(GObject.GObject):
     ## @var INSTANCE
@@ -712,20 +761,22 @@
 
     if _import_error is None:
         __gsignals__ = {
-
             # signal emitted whenever a right-click-on-node popup menu is being constructed
-            'populate-node-menu': (GObject.SignalFlags.RUN_LAST, None, (object, Gtk.Menu,)),
-
+            "populate-node-menu": (
+                GObject.SignalFlags.RUN_LAST,
+                None,
+                (
+                    object,
+                    Gtk.Menu,
+                ),
+            ),
             # signal emitted after every simulation period (SAMPLE_PERIOD seconds of simulated time)
             # the simulation lock is acquired while the signal is emitted
-            'simulation-periodic-update': (GObject.SignalFlags.RUN_LAST, None, ()),
-
+            "simulation-periodic-update": (GObject.SignalFlags.RUN_LAST, None, ()),
             # signal emitted right after the topology is scanned
-            'topology-scanned': (GObject.SignalFlags.RUN_LAST, None, ()),
-
+            "topology-scanned": (GObject.SignalFlags.RUN_LAST, None, ()),
             # signal emitted when it's time to update the view objects
-            'update-view': (GObject.SignalFlags.RUN_LAST, None, ()),
-
+            "update-view": (GObject.SignalFlags.RUN_LAST, None, ()),
         }
 
     def __init__(self):
@@ -738,14 +789,14 @@
         assert Visualizer.INSTANCE is None
         Visualizer.INSTANCE = self
         super(Visualizer, self).__init__()
-        self.nodes =  {} # node index -> Node
-        self.channels = {} # id(ns3.Channel) -> Channel
-        self.window = None # toplevel window
-        self.canvas = None # GooCanvas.Canvas
-        self.time_label = None # Gtk.Label
-        self.play_button = None # Gtk.ToggleButton
-        self.zoom = None # Gtk.Adjustment
-        self._scrolled_window = None # Gtk.ScrolledWindow
+        self.nodes = {}  # node index -> Node
+        self.channels = {}  # id(ns3.Channel) -> Channel
+        self.window = None  # toplevel window
+        self.canvas = None  # GooCanvas.Canvas
+        self.time_label = None  # Gtk.Label
+        self.play_button = None  # Gtk.ToggleButton
+        self.zoom = None  # Gtk.Adjustment
+        self._scrolled_window = None  # Gtk.ScrolledWindow
 
         self.links_group = GooCanvas.CanvasGroup()
         self.channels_group = GooCanvas.CanvasGroup()
@@ -753,7 +804,7 @@
 
         self._update_timeout_id = None
         self.simulation = SimulationThread(self)
-        self.selected_node = None # node currently selected
+        self.selected_node = None  # node currently selected
         self.speed = 1.0
         self.information_windows = []
         self._transmission_arrows = []
@@ -811,9 +862,9 @@
         main_hbox1 = GObject.new(Gtk.HBox, border_width=8, visible=True)
         main_vbox.pack_start(main_hbox1, True, True, 0)
 
-        show_transmissions_group = GObject.new(Gtk.HeaderBar,
-                                               title="Show transmissions",
-                                               visible=True)
+        show_transmissions_group = GObject.new(
+            Gtk.HeaderBar, title="Show transmissions", visible=True
+        )
         main_hbox1.pack_start(show_transmissions_group, False, False, 8)
 
         vbox = Gtk.VBox(homogeneous=True, spacing=4)
@@ -841,16 +892,19 @@
         def toggled(radio):
             if radio.get_active():
                 self.set_show_transmissions_mode(ShowTransmissionsMode.ALL)
+
         all_nodes.connect("toggled", toggled)
 
         def toggled(radio):
             if radio.get_active():
                 self.set_show_transmissions_mode(ShowTransmissionsMode.NONE)
+
         no_node.connect("toggled", toggled)
 
         def toggled(radio):
             if radio.get_active():
                 self.set_show_transmissions_mode(ShowTransmissionsMode.SELECTED)
+
         selected_node.connect("toggled", toggled)
 
         # -- misc settings
@@ -866,9 +920,11 @@
         vbox.pack_start(GObject.new(Gtk.Label, label="Node Size", visible=True), True, True, 0)
         settings_hbox.pack_start(vbox, False, False, 6)
         self.node_size_adjustment = scale.get_adjustment()
+
         def node_size_changed(adj):
             for node in self.nodes.values():
                 node.set_size(adj.get_value())
+
         self.node_size_adjustment.connect("value-changed", node_size_changed)
         self.node_size_adjustment.set_lower(0.01)
         self.node_size_adjustment.set_upper(20)
@@ -879,14 +935,16 @@
         vbox = GObject.new(Gtk.VBox, border_width=0, visible=True)
         scale = GObject.new(Gtk.HScale, visible=True, digits=1)
         vbox.pack_start(scale, True, True, 0)
-        vbox.pack_start(GObject.new(Gtk.Label, label="Tx. Smooth Factor (s)", visible=True), True, True, 0)
+        vbox.pack_start(
+            GObject.new(Gtk.Label, label="Tx. Smooth Factor (s)", visible=True), True, True, 0
+        )
         settings_hbox.pack_start(vbox, False, False, 6)
         self.transmissions_smoothing_adjustment = scale.get_adjustment()
         adj = self.transmissions_smoothing_adjustment
         adj.set_lower(0.1)
         adj.set_upper(10)
         adj.set_step_increment(0.1)
-        adj.set_value(DEFAULT_TRANSMISSIONS_MEMORY*0.1)
+        adj.set_value(DEFAULT_TRANSMISSIONS_MEMORY * 0.1)
 
         return expander
 
@@ -894,7 +952,7 @@
     class _PanningState(object):
         ## @var __slots__
         #  internal variables
-        __slots__ = ['initial_mouse_pos', 'initial_canvas_pos', 'motion_signal']
+        __slots__ = ["initial_mouse_pos", "initial_canvas_pos", "motion_signal"]
 
     def _begin_panning(self, widget, event):
         """!
@@ -913,7 +971,9 @@
         x = self._scrolled_window.get_hadjustment().get_value()
         y = self._scrolled_window.get_vadjustment().get_value()
         self._panning_state.initial_canvas_pos = (x, y)
-        self._panning_state.motion_signal = self.canvas.connect("motion-notify-event", self._panning_motion)
+        self._panning_state.motion_signal = self.canvas.connect(
+            "motion-notify-event", self._panning_motion
+        )
 
     def _end_panning(self, event):
         """!
@@ -979,6 +1039,7 @@
 
     def get_hadjustment(self):
         return self._scrolled_window.get_hadjustment()
+
     def get_vadjustment(self):
         return self._scrolled_window.get_vadjustment()
 
@@ -996,7 +1057,8 @@
         self.canvas.props.has_tooltip = True
         self.canvas.connect("query-tooltip", self._canvas_tooltip_cb)
         self.canvas.show()
-        sw = Gtk.ScrolledWindow(); sw.show()
+        sw = Gtk.ScrolledWindow()
+        sw.show()
         self._scrolled_window = sw
         sw.add(self.canvas)
         vbox.pack_start(sw, True, True, 4)
@@ -1004,7 +1066,6 @@
         self.canvas.set_bounds(-10000, -10000, 10000, 10000)
         self.canvas.scroll_to(0, 0)
 
-
         self.canvas.get_root_item().add_child(self.links_group, -1)
         self.links_group.set_property("visibility", GooCanvas.CanvasItemVisibility.VISIBLE)
 
@@ -1018,17 +1079,24 @@
 
         self.hud = hud.Axes(self)
 
-        hbox = Gtk.HBox(); hbox.show()
+        hbox = Gtk.HBox()
+        hbox.show()
         vbox.pack_start(hbox, False, False, 4)
 
         # zoom
-        zoom_adj = Gtk.Adjustment(value=1.0, lower=0.01, upper=10.0,
-                                  step_increment=0.02,
-                                  page_increment=1.0,
-                                  page_size=1.0)
+        zoom_adj = Gtk.Adjustment(
+            value=1.0,
+            lower=0.01,
+            upper=10.0,
+            step_increment=0.02,
+            page_increment=1.0,
+            page_size=1.0,
+        )
         self.zoom = zoom_adj
+
         def _zoom_changed(adj):
             self.canvas.set_scale(adj.get_value())
+
         zoom_adj.connect("value-changed", _zoom_changed)
         zoom = Gtk.SpinButton.new(zoom_adj, 0.1, 1)
         zoom.set_digits(3)
@@ -1038,13 +1106,15 @@
         _zoom_changed(zoom_adj)
 
         # speed
-        speed_adj = Gtk.Adjustment(value=1.0, lower=0.01, upper=10.0,
-                                   step_increment=0.02,
-                                   page_increment=1.0, page_size=0)
+        speed_adj = Gtk.Adjustment(
+            value=1.0, lower=0.01, upper=10.0, step_increment=0.02, page_increment=1.0, page_size=0
+        )
+
         def _speed_changed(adj):
             self.speed = adj.get_value()
-            self.sample_period = SAMPLE_PERIOD*adj.get_value()
+            self.sample_period = SAMPLE_PERIOD * adj.get_value()
             self._start_update_timer()
+
         speed_adj.connect("value-changed", _speed_changed)
         speed = Gtk.SpinButton.new(speed_adj, 1, 0)
         speed.set_digits(3)
@@ -1059,10 +1129,13 @@
         hbox.pack_start(self.time_label, False, False, 4)
 
         # Screenshot button
-        screenshot_button = GObject.new(Gtk.Button,
-                                        label="Snapshot",
-                                        relief=Gtk.ReliefStyle.NONE, focus_on_click=False,
-                                        visible=True)
+        screenshot_button = GObject.new(
+            Gtk.Button,
+            label="Snapshot",
+            relief=Gtk.ReliefStyle.NONE,
+            focus_on_click=False,
+            visible=True,
+        )
         hbox.pack_start(screenshot_button, False, False, 4)
 
         def load_button_icon(button, icon_name):
@@ -1078,24 +1151,31 @@
 
         # Shell button
         if ipython_view is not None:
-            shell_button = GObject.new(Gtk.Button,
-                                       label="Shell",
-                                       relief=Gtk.ReliefStyle.NONE, focus_on_click=False,
-                                       visible=True)
+            shell_button = GObject.new(
+                Gtk.Button,
+                label="Shell",
+                relief=Gtk.ReliefStyle.NONE,
+                focus_on_click=False,
+                visible=True,
+            )
             hbox.pack_start(shell_button, False, False, 4)
             load_button_icon(shell_button, "gnome-terminal")
             shell_button.connect("clicked", self._start_shell)
 
         # Play button
-        self.play_button = GObject.new(Gtk.ToggleButton,
-                                       label="Simulate (F3)",
-                                       relief=Gtk.ReliefStyle.NONE, focus_on_click=False,
-                                       visible=True)
+        self.play_button = GObject.new(
+            Gtk.ToggleButton,
+            label="Simulate (F3)",
+            relief=Gtk.ReliefStyle.NONE,
+            focus_on_click=False,
+            visible=True,
+        )
         load_button_icon(self.play_button, "media-playback-start")
         accel_group = Gtk.AccelGroup()
         self.window.add_accel_group(accel_group)
-        self.play_button.add_accelerator("clicked", accel_group,
-                                         Gdk.KEY_F3, 0, Gtk.AccelFlags.VISIBLE)
+        self.play_button.add_accelerator(
+            "clicked", accel_group, Gdk.KEY_F3, 0, Gtk.AccelFlags.VISIBLE
+        )
         self.play_button.connect("toggled", self._on_play_button_toggled)
         hbox.pack_start(self.play_button, False, False, 4)
 
@@ -1125,7 +1205,10 @@
         for nodeI in range(ns.NodeList.GetNNodes()):
             seen_nodes += 1
             if seen_nodes == 100:
-                print("scan topology... %i nodes visited (%.1f%%)" % (nodeI, 100*nodeI/ns.NodeList.GetNNodes()))
+                print(
+                    "scan topology... %i nodes visited (%.1f%%)"
+                    % (nodeI, 100 * nodeI / ns.NodeList.GetNNodes())
+                )
                 seen_nodes = 0
             node = ns.NodeList.GetNode(nodeI)
             node_name = "Node %i" % nodeI
@@ -1136,7 +1219,7 @@
                 node_view.set_color("red")
                 pos = ns.cppyy.gbl.getNodePosition(node)
                 node_view.set_position(*transform_point_simulation_to_canvas(pos.x, pos.y))
-                #print "node has mobility position -> ", "%f,%f" % (pos.x, pos.y)
+                # print "node has mobility position -> ", "%f,%f" % (pos.x, pos.y)
             else:
                 graph.add_node(node_name)
 
@@ -1181,12 +1264,12 @@
         print("scanning topology: calling graphviz layout")
         graph.layout(LAYOUT_ALGORITHM)
         for node in graph.iternodes():
-            #print node, "=>", node.attr['pos']
-            node_type, node_id = node.split(' ')
-            pos_x, pos_y = [float(s) for s in node.attr['pos'].split(',')]
-            if node_type == 'Node':
+            # print node, "=>", node.attr['pos']
+            node_type, node_id = node.split(" ")
+            pos_x, pos_y = [float(s) for s in node.attr["pos"].split(",")]
+            if node_type == "Node":
                 obj = self.nodes[int(node_id)]
-            elif node_type == 'Channel':
+            elif node_type == "Channel":
                 obj = self.channels[int(node_id)]
             obj.set_position(pos_x, pos_y)
 
@@ -1201,7 +1284,9 @@
             self.nodes[index] = node
             self.nodes_group.add_child(node.canvas_item, -1)
             node.canvas_item.connect("button-press-event", self.on_node_button_press_event, node)
-            node.canvas_item.connect("button-release-event", self.on_node_button_release_event, node)
+            node.canvas_item.connect(
+                "button-release-event", self.on_node_button_release_event, node
+            )
             return node
 
     def get_channel(self, ns3_channel):
@@ -1219,7 +1304,7 @@
         link.canvas_item.lower(None)
 
     def update_view(self):
-        #print "update_view"
+        # print "update_view"
 
         self.time_label.set_text("Time: %f s" % ns.Simulator.Now().GetSeconds())
 
